<?php 
/////////////////////////////////
// addmember.php3 version 2.5.2
// FABRE Arnaud           2004
/////////////////////////////////

if (!defined('IN_ADMIN'))
{
  exit();
}

//
// include librarie that allow crypting the password
//
include($repertorylevel.'include/pass.inc.'.$e);

//
// construct $statut var
//
$statut = ST_USER;

if (defined('ADMIN_ZONE'))
{
  if (isset($isAdmin)) $statut |= ST_ADMIN;
  if (isset($isWebmaster)) $statut |= ST_WEBMASTER;
  if (isset($isModerator)) $statut |= ST_MOD;
}
//
// Effective addition
//
$erreur = '';

if (!isset($private_forum))
{
  $private_forum = array();
}

if (isset($passwordacrypter) && isset($passwordacrypterconfirm) && isset($loginarentrer))
{
  if (!eregi("^[[:alnum:]]{2,20}$",$loginarentrer) != false)
    {
      $erreur = 'badlogin';
    }
  if ($passwordacrypter == '')
    {
      $erreur = 'incomplete form';
    }
  if ($loginarentrer == '')
    {
      $erreur = 'incomplete form';
    }
  //
  // test if the confirmation of the password match
  //
  if ($passwordacrypter != $passwordacrypterconfirm)
    {
      $erreur = 'badpasswordconfirm';
    }

  //
  // Test if the login already in use
  //
  if ($erreur == '' && $DB->num_rows($DB->query('SELECT id FROM '.MEMBRES_TABLE.' WHERE login=\''.$loginarentrer.'\' LIMIT 1')) != 0)
    {
      $erreur = 'login already exist';
    }

  //
  // Create the $acces value
  //
  $DB->query('SELECT id, acces FROM '.SECTION_TABLE);
  $acces = 0;
  $allowedforum = array();
  $moderationforum = 0;

  //
  // Pass all forums
  //
  while ($forum = $DB->fetch_array())
    {
      //
      // If the user is an Administrator, if have all access
      //
      if ($statut & ST_ADMIN)
	{
	  $moderationforum = $moderationforum | (1 << ($forum['id'] - 1));
	  $acces = $acces | (1 << ($forum['id'] - 1));
	  $allowedforum[] = $forum['id'];
	  continue;
	}

      //
      // Otherwise, test if the forum is public or not, and, if not, if the user is allowed to see it or not
      //

      if ($forum['acces'] & FOR_PRIVATE)
	{
	  if (isset($private_forum[$forum['id'] - 1]) && $private_forum[$forum['id'] - 1])
	    {
	      $acces = $acces | (1 << ($forum['id'] - 1));
	      $allowedforum[] = $forum['id'];
	    }
	}
      else
	{
	  $acces = $acces | (1 << ($forum['id'] - 1));
	  $allowedforum[] = $forum['id'];
	}
    }

  //
  // Compute the next available id
  //
  $newMemberId = $DB->fetch_array($DB->query('SELECT MAX(id) AS max FROM '.MEMBRES_TABLE));
  $newMemberId = $newMemberId['max'] + 1;

  if ($erreur == '' && !$result = $DB->query('INSERT INTO '.MEMBRES_TABLE."
 (id, login, password, activation_key, statut, sign, pseudo, acces, view, mod, nt, tpp, email, keepmail, icq, birthdate,
city, countrie, skin, popup, photo, creation, lastaccess, neverdel, invisible, lang)
VALUES ('$newMemberId','$loginarentrer','".cryptPassword($passwordacrypter)."','','$statut','--\n$loginarentrer','$loginarentrer','$acces','$acces','$moderationforum','case','20','','yes',0,0,'','','default/skin.css|default','yes','','".date('Y-m-d H:i:s', time() - 300)."','".date('Y-m-d H:i:s', time() - 300)."','no','no','".$config->defaultLang."')"))
    {
      $erreur = 'mysql_add';
    }

  //
  // Nonread msg mark addition if still no error
  //
  if ($erreur == '')
    {
      reset($allowedforum);
      $MemberToMarkId = $newMemberId;

      //
      // For each allowed forum, add mark
      //
      while ($forumToMark = current($allowedforum))
	{
	  next($allowedforum);
	  include($repertorylevel.'include/addmark.'.$e);
	}
    }
  //
  // End of the script : the member's addition is effective
  //
}
else
{
  $erreur = 'incomplete form';
}
?>
