<?php
//////////////////////////////////
// forum82lib.php3   version 2.5.2
// FABRE Arnaud    2004
//////////////////////////////////


//
// code executed at each display of a page : connection to the database
//
if (!defined('FORUM82LIB'))
{
  define('FORUM82LIB',true);

  if (PHP_VERSION >= '4.1.0')
    {
      @import_request_variables('gpc');
    }

  if (!isset($repertorylevel))
    {
      $repertorylevel = './';
    }

  //
  // Start counter
  //
  $starttime = microtime();
  $starttime = explode(' ', $starttime);
  $starttime = $starttime[0] + $starttime[1];

  $DoGZip = false;

  /******************************************************
   * @function : mysql_disconnect()
   * @param    : none
   * @return   : no value
   * @action   : Disconnect from the database
   *             Must be called at the end of each page
   ****************************************************/
  function mysql_disconnect()
    {
      global $DB;

      //
      // if a connection exist, then disconnect
      //
      $DB->disconnect();
    }

  function DetermineTemplate()
    {
      global $config, $pathTemplate, $skinFile, $skin, $tMember;
      if ($config->useSkin)
	{
	  if (isset($skin))
	    $template = $skin;
	  else if (!isset($tMember['login']))
	    $template = 'default/skin.css|default';
	  else if ($tMember['skin'] == '')
	    $template = $tMember['login'];
	  else $template = $tMember['skin'];
	}
      else
	{
	  $template = 'default/skin.css|default';
	}

      list($skinFile, $pathTemplate) = explode('|', $template);
    }

  /**************************************************************
   * @function : InsertSkin
   * @param    : none
   * @return   : no value
   * @action   : Insert the necessary HTML code to have the skin
   **************************************************************/
  function InsertHeader($title = 'Forum82')
    {
      global $repertorylevel, $skin, $tMember, $config, $DoGZip, $pathTemplate, $skinFile;

      if ($config->gZipCompression)
	{
	  $phpver = phpversion();

	  //
	  // GZip compression borrowed from phpbb2
	  //
	  if($phpver >= '4.0.4pl1')
	    {
	      if(extension_loaded('zlib'))
		{
		  ob_start('ob_gzhandler');
		  $DoGZip = true;
		}
	    }
	  else if($phpver > '4.0')
	    {
	      if(strstr($HTTP_SERVER_VARS['HTTP_ACCEPT_ENCODING'], 'gzip'))
		{
		  if(extension_loaded('zlib'))
		    {
		      $DoGZip = true;
		      ob_start();
		      ob_implicit_flush(0);

		      header('Content-Encoding: gzip');
		    }
		}
	    }
	}

      if (0)
	{
	  print('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">');
	}

      print( "\n<HTML>\n<HEAD>\n<TITLE>$title</TITLE>\n");
      print( '<LINK rel="stylesheet" type="text/css" href="'.$repertorylevel.'template/'.$skinFile.'">'."\n");

    }

  // extension of the php files.
  // You have to rename files with this extension, so that the server recognizes them as php files, except for forum82lib.php3
  include($repertorylevel.'extension.inc');

  //
  // If $claimedStatut not set, then set it to ''
  //
  if (!isset($claimedStatut))
    {
      $claimedStatut = '';
    }

  //
  // If repertorylevel not set, then we are in forum/
  //
  if (!isset($repertorylevel))
    {
      $repertorylevel = '';
    }


  //
  // If the page which called this file is a Library, then this file must have already been included
  //
  if ($claimedStatut == 'LibraryFunction')
    {
      $title = 'Page de librairie';
      $body = '<FONT class=indexText>Cette page n\'est pas destine  tre vue. Cliquez <A href="javascript: history.back();">ici</A>';
      include($repertorylevel.'include/error.inc.'.$e);
      exit;
    }

  require($repertorylevel.'include/constants.inc.'.$e);
  require($repertorylevel.'config.'.$e);
  //define tablename constants
  require($repertorylevel.'include/tables.inc.'.$e);
  require($repertorylevel.'lang/lang.inc.'.$e);
  require($repertorylevel.'include/db/mysql.inc.'.$e);

  $DB = new CMysql();

  //connect to the database
  $DB->connect($config->host, $config->mysql_account, $config->mysql_password, $config->mysql_db, $config->persistence);

  $authorize = false;
  require($repertorylevel.'auth.inc.'.$e);


  if ($claimedStatut == 'noConnection')
    {
      mysql_disconnect();
    }

  /*
   * Insert the end of the page : copyright and info version, time of generation and then it close the body and the html tag
   */
  function InsertFooter($gZip = true)
    {
      global $starttime, $config, $DoGZip, $DB;
      mysql_disconnect();

      $endtime = microtime();
      $endtime = explode(' ', $endtime);
      $endtime = $endtime[0] + $endtime[1];

      $time = round(($endtime - $starttime) * 1000000) / 1000000;

      print('<CENTER><FONT color=white size=1>Forum bas sur Forum82 v'.FORUM82_VERSION.', dvelopp par FABRE Arnaud</FONT><BR><FONT class=body>Page gnre en '.$time.' secondes</FONT><BR>');

      if (DEBUG >= 1)
	{
	  echo $DB->GetStats();

	  if (DEBUG >= 2)
	    {
	      echo '<TABLE cellspacing=0 style="border: solid 1pt">';
	      echo '<TR><TH>Query<TH>Time';
	      for ($i = 1; $i <= $DB->GetNbQueries(); $i++)
		{
		  $q = $DB->GetQuery($i);

		  if ($q['time'] >= 0.02)
		    {
		      echo '<TR class=highlight'.($i%2 + 1).'><TD><SPAN style="color:red">'
			.$q['query'].'</SPAN><TD><SPAN style="color:red">'.$q['time'].'</SPAN>';
		}
		  else
		    {
		  echo '<TR class=highlight'.($i%2 + 1).'><TD>'.removeHtmlChar($q['query']).'<TD>'.$q['time'];
		    }
		}
	      echo '</TABLE>';
	    }
	}

      echo '</CENTER></BODY>'."\n".'</HTML>';

      if ($config->gZipCompression && $gZip && $DoGZip && 0)
	{
	  $gzip_contents = ob_get_contents();
	  ob_end_clean();

	  $gzip_size = strlen($gzip_contents);
	  $gzip_crc = crc32($gzip_contents);

	  $gzip_contents = gzcompress($gzip_contents, 9);
	  $gzip_contents = substr($gzip_contents, 0, strlen($gzip_contents) - 4);

	  echo "\x1f\x8b\x08\x00\x00\x00\x00\x00";
	  echo $gzip_contents;
	  echo pack("V", $gzip_crc);
	  echo pack("V", $gzip_size);
	}
    }

  /*
   * Create a javascript block that define variables
   * The variables are passed in a array where the index is the variable name and the value the corresponding value
   * It can be constructed in this way : array( "nameOfVar" => "ValueOfVar", ...);
   */
  function CreateJScriptVar($var)
    {
      $code = "<SCRIPT type=\"text/javascript\">\n<!--\n";
      while (list($name, $val) = each($var))
	$code .= "var $name = $val;\n";
      $code .= "//-->\n</SCRIPT>\n";
      print($code);
    }

  //
  // If necessary, AddSlashes to all posted var
  //
  function Slash(&$table)
    {
      reset($table);
      $i = count($table);
      while (list($key, $value) = each($table))
	{
	  if (is_array($value))
	    Slash($table[$key]);
	  else
	    {
	      global $$key;
	      $$key = AddSlashes($$key);
	    }
	}
    }

  //
  // Assert that magic_quotes_runtime isn't set
  //
  set_magic_quotes_runtime(0);

  //
  // Call Slash function to necessary variables
  //
  if (!$config->magic_quotes)
    {
	Slash($HTTP_POST_VARS);
	Slash($HTTP_COOKIE_VARS);
    }

  function removeHtmlChar($text)
    {
      $text = str_replace('&', '&amp;', $text);
      $text = str_replace('<', '&lt;', $text);
      $text = str_replace('>', '&gt;', $text);
      $text = str_replace('"', '&quot;', $text);
      return $text;
    }
}
?>
