<?php 
/////////////////////////////////
// $Header: d:\\cvs/forum82/forum/include/date.inc.php3,v 1.6 2002/06/18 00:02:48 Administrateur Exp $
// date.inc.php3    version 2.07
// FABRE Arnaud             2001
////////////////////////////////

if (!defined('DATE_LIB'))
{
  define('DATE_LIB', true);

  /*************************************************************************************
   * @function : format_date
   * @param    : date : date and time at mysql standard format (YYYY-MM-DD HH:MM:SS)
   * @return   : the datetime formatted according to actual time :
   *		  - if the date is the same day, then it produces "Aujourd'hui @ HH:MM"
   *		  - if the date is yesterday, it produces "Hier @ HH:MM"
   *		  - otherwise, it produces "le DD/MM/YY @ HH:MM"
   *************************************************************************************/
  function format_date($datetime)
    {
      global $lang;

      list($year, $month, $day, $hour, $minute, $seconds) = ExtractDate($datetime);
      $date = $year.'-'.$month.'-'.$day;
      //
      // The date is today
      //
      if ($date == date('Y-m-d'))
	{
	  return $lang['today'].' @ '.$hour.':'.$minute;
	}
      //
      // The date is yesterday
      //
      if ($date == date('Y-m-d', time() - 86400))
	{
	  return $lang['yesterday'].' @ '.$hour.':'.$minute;
	}
      
      //
      // Otherwise, show standard format date
      //
      return date($lang['dateFormat'], mktime($hour, $minute, $seconds, $month, $day, $year));
      //      return 'le '.$day.'/'.$month.'/'.(substr($year, 2, 2)).' @ '.$hour.':'.$minute;
    }

  /************************
   * take a string like mysql return it
   * and return a array listing, in that order :
   * year, month, day, hour, minut, seconds
   ************************/
  function ExtractDate($string)
    {
      list($date, $time) = explode(' ', $string);
      list($year, $month, $day) = explode('-', $date);
      list($hour, $minut, $seconds) = explode(':', $time);

      return (array ('year'    => $year,
		     0         => $year,
		     'month'   => $month,
		     1         => $month,
		     'day'     => $day,
		     2         => $day,
		     'hour'    => $hour,
		     3         => $hour,
		     'minut'   => $minut,
		     4         => $minut,
		     'seconds' => $seconds,
		     5         => $seconds) );
    }

  function format_day($date)
    {
      list($year, $month, $day) = explode('-', $date);
      return $day.'/'.$month.'/'.$year;
    }
}
?>