<?php
////////////////////////////////
// forms.inc.php3 version 2.5.2b
// FABRE Arnaud             2004
////////////////////////////////

/******************************************
 * return code of a select :
 * selecInfo['name'] : property name
 *          ['id']   : id
 * data : array of array :
 * date[i]['value']  : value of OPTION tag
 * date[i]['text']   : text displayed in
 *                     the option
 * selected : value that has to be selected
 *****************************************/
function InsertSelect($selectInfo, $data, $selected = '')
{
  $code = '<SELECT';
  if (isset($selectInfo['id']))
    {
      $code .= ' id="'.$selectInfo['id'].'"';
    }

  if (isset($selectInfo['name']))
    {
      $code .= ' name="'.$selectInfo['name'].'"';
    }

  if (isset($selectInfo['onchange']))
    {
      $code .= ' onchange="'.$selectInfo['onchange'].'"';
    }

  if (isset($selectInfo[0]))
    {
      $code .= ' '.$selectInfo[0];
    }

  $code .= ">\n";

  reset($data);
  while ( $d = each($data) )
    {
      $code .= '  <OPTION';
      if (isset($d[1]['value']))
	{
	  $code .= ' value="'.$d[1]['value'].'"';

	  if ($selected == $d[1]['value'])
	    {
	      $code .= ' selected';
	    }
	}

      $code .= '>'.$d[1]['text']."\n";
    }

  $code .= '</SELECT>';

  return $code;
}

/*****************************
 * Return the code of an input
 * conresponding to the data
 * provided
 *****************************/
function InsertInput($d)
{
  $code = '<INPUT';

  while (list($property, $name) = each($d))
    {
      if (is_integer($property))
	{
	  $code .= ' '.$name;
	}
      else
	{
	  $code .= ' '.$property.'="'.$name.'"';
	}
    }
  $code .= ">\n";

  return $code;
}

/*****************************
 * Return the code of a textarea
 * conresponding to the data
 * provided, and filled with
 * an optional $text
 *****************************/
function InsertTextArea($data, $text = '')
{
 $code = '<TEXTAREA';

  while (list($property, $name) = each($data))
    {
      $code .= ' '.$property.'="'.$name.'"';
    }
  $code .= '>';

  $code .= $text."</TEXTAREA>\n";

  return $code;
}

Class Table
{
  // Structure of this data :
  // $table    => info about table
  // $colgroup => info about colgroup
  // $tr[i]    => info about tr number i
  // $td[i][j] => info about td number j, within columns i
  // datas are stored with this format :
  // array ( 'attribute' => 'value' );
  //
  // $data[$i.'_'.$j] => HTML code of TD number j, within columns i
  var $table;
  var $colgroup;
  var $col;
  var $tr;
  var $td;
  var $data;

  var $currentRow;
  var $currentCol;

  //Constructor
  function Table()
    {
      $this->table = array();
      $this->colgroup = array();
      $this->tr = array();
      $this->td = array( array() );
      $this->data = array();
      $this->col = array();
      $this->currentRow = 0;
      $this->currentCol = 0;
    }

  function Reset()
    {
      $this->Table();
    }

  function SetTableParam($params)
    {
      $this->table = $params;
    }

  function SetColGroup($params)
    {
      $this->cologroup = $params;
    }

  function DeclareCol($params)
    {
      $this->col[] = $params;
    }

  function AddRows($rowParams, $isHeader = false)
    {
      $this->currentRow++;
      $this->tr[ $this->currentRow ] = $rowParams;
      $this->header[ $this->currentRow ] = $isHeader;
      $this->currentCol = 0;
    }

  function AddCell($params, $html)
    {
      $this->td[ $this->currentRow ][ $this->currentCol  ] = $params;
      $this->data[ $this->currentRow.'_'.$this->currentCol ] = $html;
      $this->currentCol++;
    }

  function InsertTable()
    {
      print($this->GetTableCode());
    }

  function GetTableCode()
    {
      //main tag
      $code = $this->CreateTag('TABLE', $this->table)."\n";

      //colgroup bloc
      if (sizeof($this->col))
	{
	  $code .= '  '.$this->CreateTag('COLGROUP', $this->colgroup)."\n";

	  reset($this->col);
	  while (list($unused, $colInfo) = each($this->col))
	    {
	      $code .= '    '.$this->CreateTag('COL', $colInfo)."\n";
	    }
	  $code .= "  </COLGROUP>\n";
	}

      reset($this->tr);
      while (list($currentRow, $TrInfo) = each($this->tr))
	{
	  $code .= '    '.$this->CreateTag('TR', $TrInfo)."\n";

	  reset($this->td[$currentRow]);
	  while (list($currentCell, $tdInfo) = each($this->td[$currentRow]))
	    {
	      $code .= '      '.$this->CreateTag($this->header[ $currentRow ]? 'TH': 'TD',
						 $tdInfo).$this->data[$currentRow.'_'.$currentCell]
						 .($this->header[ $currentRow ]? '</th>' : '</td>')
						 ."\n";
	    }
	}

      $code .= '</TABLE>';
      return $code;
    }

  //Internal function => should not be used
  function CreateTag($TagName, $att)
    {
      $code = '<'.$TagName;

      reset($att);
      while (list($name, $value) = each($att))
	{
	  $code .= ' '.$name.'="'.$value.'"';
	}
      $code .= '>';

      return $code;
    }
}

Class PageNavigation
{
  var $code;

  function PageNavigation()
    {
      $this->Reset();
    }

  //
  // Reset the object
  //
  function Reset()
    {
      $this->code = '';
    }

  //
  // Call this function to construct the table
  // $min, $max : limits of pages that can be displayed
  //
  function CreatePageNavigation($min, $max, $currentpage, $baseUrl, $maxPagesDisplayed = 10, $showLimits = true)
    {
      global $lang;
      if ($min != $max)
	{
	  //Create table that will contains the links
	  $table = new Table();
	  $table->SetTableParam( array( 'class'       => 'tool',
					'cellpadding' => 0,
					'align'       => 'center',
					'style'       => 'align:center;border:0pt;width:90%'));
	  $table->AddRows( array() );

	  $table->AddCell( array('style' => 'text-align:left;width:130pt;'),
			   ($currentpage != $min)
			   ?'<B><A href="'.$baseUrl.'page='.($currentpage - 1).'" class=tool>'.$lang['previous_page'].'</A></B>'
			   : '&nbsp;');

	  //Insert the left limit
	  $nav = '<B>';
	  if ($showLimits)
	    {
	      if ($min != $currentpage)
		{
		  $nav .= '<A href="'.$baseUrl.'page='.$min.'" class=tool>'.$lang['beginning'].'</A> ... &nbsp;';
		}
	    }

	  //process the needed page links
	  $start = ceil(($currentpage - ($maxPagesDisplayed / 2)));

	  $start = ($start < $min) ? $min : $start;

	  for ($i = $start
		 ;($i <=  floor($currentpage + ($maxPagesDisplayed / 2)))
		 && ($i <= $max)
		 ; $i++)
	    {
	      if ($i != $currentpage)
		{
		  $nav .= '<A href="'.$baseUrl.'page='.$i.'" class=tool>'.$i.'</A> &nbsp;';
		}
	      else
		{
		  $nav .= '</B>'.$i.'<B> &nbsp;';
		}
	    }

	  //Insert the right limit
	  if ($showLimits)
	    {
	      if ($max != $currentpage)
		{
		  $nav .= '&nbsp; ... &nbsp;<A href="'.$baseUrl.'page='.$max.'" class=tool>'.$lang['end'].'</A></b>';
		}
	      /*else
		{
		$nav .= '</B> ... Fin<B>';

		}*/
	    }

	  $table->AddCell( array('style' => 'text-align:center;'), $nav);

	  $table->AddCell( array('style' => 'text-align:right;width:130pt'),
			   ($currentpage != $max)
			   ?'<B><A href="'.$baseUrl.'page='.($currentpage + 1).'" class=tool>'.$lang['next_page'].'</A></B>'
			   : '&nbsp;');

	  $this->code = $table->GetTableCode();
	}
    }

  //
  // Insert the table, so that it is possible to use the page navigation many time
  // with no lost of time
  //
  function InsertNavigation()
    {
      print($this->code);
    }

  //
  // Return the code that correspond to the navigation
  //
  function GetCode()
    {
      return $this->code;
    }
}

//Class that create a box allowing forum selection
Class CForumSelect
{
  var $mforums;
  var $mselected;
  var $mMask;
  var $mShowSubmit;
  var $mShowId;

  //
  // Construct the object
  function CForumSelect()
    {
      // include required lib
      global $repertorylevel, $e;
      include($repertorylevel.'include/cat.'.$e);

      // retrieve forums
      $this->mforums = array();
      getForums($this->mforums);

      //
      // Set default mask (allow all forums)
      $this->mMask = ~0;

      //
      // Initialize others var
      $this->mShowSubmit = false;
      $this->mShowId = false;
    }

  //
  // Retrieve data from GET / POST data
  function RestoreState()
    {
      global $_forumsSelect;

      if (isset($_forumsSelect))
	{
	  $this->mselected = $_forumsSelect;
	}
      else
	{
	  $this->mselected = array();
	}
      $this-> CheckForumList();
    }

  function CheckForumList()
    {
      reset($this->mforums);
      $forums = array();
      while (list($unused, $f) = each($this->mforums))
	{
	  if ($this->mMask & (1 << ($f['id'] - 1)))
	    {
	      $forums[] = $f;
	    }
	}
      $this->mforums = $forums;
    }

  function GetNbSelectedForums()
    {
      return sizeof($this->mselected);
    }

  //
  // Return the additionnal data needed to the class
  function GetQueryUrl()
    {
      $url = '';
      //list selected forums
      reset($this->mselected);
      while (list($idforum, $unused) = each($this->mselected))
	{
	  $url .= '_forumsSelect['.$idforum.']=1&amp;';
	}
      // put away the additionall &amp; at the end
      return substr($url, 0, -5);
    }

  //
  // Return the list of selected forums
  function GetSelectedForums()
    {
      reset($this->mselected);
      $result = array();
      while(list($id, $unused) = each($this->mselected))
	{
	  $result[] = $id;
	}
      return $result;
    }

  //
  // allow to select a forum
  function SelectForum($id, $select = true)
    {
      if ($select)
	{
	  $this->mselected[$id] = 1;
	}
      else
	{
	  unset($this->mselected[$id]);
	}
    }

  //
  // Deselect all forums
  function ResetAll()
    {
      $this->mselected = array();
    }

  //
  // Update the mShowSubmit value
  function SetShowSubmit($value)
    {
      $this->mShowSubmit = $value;
    }
  //
  // Update the mShowId value
  function SetShowId($value)
    {
      $this->mShowId = $value;
    }
  //
  // Set mMask (MUST be called before RestoreState)
  function SetMask($mask)
    {
      $this->mMask = $mask;
    }

  //
  // Insert the box
  function InsertNavBox()
    {
      global $lang;

      $tab = new Table();
      $tab->SetTableParam(array('width' => '400pt', 'cellspacing' => '0pt', 'style' => 'border:solid 1pt'));

      $tab->DeclareCol(array('width' => '200pt'));
      $tab->DeclareCol(array('width' => '200pt'));

      $tab->AddRows(array(), true);
      $tab->AddCell(array('colspan' => 2, 'onclick' => 'SwapForumSelect();', 'style' => 'cursor:hand;'),
      			$lang['forum_list'].' &nbsp;&nbsp;&nbsp;<A href="#" onclick="return false"><SPAN id="_forumSelect">&lt;&lt;</SPAN></A>');

      reset($this->mforums);
      $nbForums = 0;
      while (list($unused, $f) = each($this->mforums))
	{ // enumerate forums
	  if (!($nbForums%2))
	    {
	      $tab->AddRows(array('class' => 'highlight'.(($nbForums / 2)%2 + 1),
				  'id'    => '_forumSelect'.$nbForums));
	    }

	  $input = array('type' => 'checkbox',
			 'name' => '_forumsSelect['.$f['id'].']',
			 'id' => '_forumsSelect['.$f['id'].']');

	  if (isset($this->mselected[$f['id']]))
	    {
	      $input[] = 'checked';
	    }

	  $text = '<label for="_forumsSelect['.$f['id'].']">'.InsertInput($input).htmlspecialchars($f['name']);
	  if ($this->mShowId)
	    {
	      $text .= ' ('.$lang['id'].' : '.$f['id'].')';
	    }
	  $text .= '</label>';

	  $tab->AddCell(array(), $text);
	  $nbForums++;
	}

      if ($nbForums%2)
	{
	  $tab->AddCell(array(), '&nbsp;');
	}

      if ($this->mShowSubmit)
	{
	  $tab->AddRows(array('id' => 'forumSelectSubmit'));
	  $tab->AddCell(array('colspan' => 2, 'style' => 'text-align:center'), '<INPUT type=submit value="'.$lang['show'].'">');
	}

      // script function that allow to show / hide the forum
      echo '<SCRIPT type="text/javascript">
 <!--
 hidden = false;
 function SwapForumSelect()
 {
   if (document.all)
     style = \'inline\';
   else
     style = \'table-row\';
   if (hidden)
    {
      for (i = 0; i < '.$nbForums.'; i+=2)
      {
        document.getElementById(\'_forumSelect\' + i).style.display = style;
      }
      document.getElementById(\'_forumSelect\').innerHTML = \'&lt;&lt;\';
      if (document.getElementById(\'forumSelectSubmit\') != null)
      {
	document.getElementById(\'forumSelectSubmit\').style.display = style;
      }
    }
   else
    {
       for (i = 0; i < '.$nbForums.'; i+=2)
        document.getElementById(\'_forumSelect\' + i).style.display = \'none\';
      document.getElementById(\'_forumSelect\').innerHTML = \'&gt;&gt;\';
      if (document.getElementById(\'forumSelectSubmit\') != null)
      {
	document.getElementById(\'forumSelectSubmit\').style.display = \'none\';
      }
    }
    hidden = !hidden;
 }
 //-->
 </SCRIPT>';

      $tab->InsertTable();

      echo '<SCRIPT type="text/javascript">
  <!--
  SwapForumSelect();
  //-->
  </SCRIPT>';
	}
}
?>
