<?php 
////////////////////////////
// $Header$
// ip.inc.php3  version 2.07
// FABRE Arnaud         2002
////////////////////////////

/**************************
 * take a valid ip and
 * convert it to an integer
 **************************/
function EncodeIP($Sip)
{
  $ip = explode('.', $Sip);
  return ($ip[3])   //first octet
    + ($ip[2] << 8) //second octet
    + ($ip[1] << 16) //...
    + ($ip[0] << 24);
}

/**********************************
 * Take an integer (like the one
 * returned by EncodeIP) and
 * return a string containing
 * the ip
 *********************************/
function DecodeIP($Iip)
{
  $result = '';
  for ($i = 24; $i >= 0; $i -= 8)
  {
    $result .= (string)(($Iip >> $i) & 255).'.';
  }

  $result = substr($result, 0, -1);

  return $result;
}

function GetIp()
{
  global $HTTP_PROXY_USER, $REMOTE_ADDR;
  if (isset($HTTP_PROXY_USER))
    {
      $ip = $HTTP_PROXY_USER;
    }
  elseif(isset($REMOTE_ADDR))
    {
      $ip = $REMOTE_ADDR;
    }
  elseif (isset($_SERVER['REMOTE_ADDR']))
  {
    $ip = $_SERVER['REMOTE_ADDR'];
  }
  else
    {
      $ip = '0.0.0.0';
    }

  if (!preg_match( "/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/", "\\1.\\2.\\3.\\4", $ip))
    {
      //can retrieve the ip
      $ip = '0.0.0.0';
    }
  return $ip;
}
?>