<?php
//////////////////////////////
// $Header: d:\\cvs/forum82/forum/include/mail.inc.php3,v 1.5 2002/06/18 00:02:48 Administrateur Exp $
// mail.inc.php3  version 2.07
// FABRE Arnaud           2002
//////////////////////////////

/*
 * require popup field in tMember
 */

//
// Include functions that performs text modifications
//
include(dirname($_SERVER['SCRIPT_FILENAME']).'/include/text.'.$e);

//
// will contains unread Msg
$nonReadMail = array();

function PreloadMail()
{
  //
  // Retrieve global infos
  //
  global $tMember, $memberid, $e, $repertorylevel, $nonReadMail, $DB;

  //
  // Assert user is not a visitor
  //
  if (IsVisitor())
    {
      return;
    }

  //
  // Check that popup field has been retrieved
  //
  if (!isset($tMember['popup']))
    {
      $title = 'Erreur';
      $body = '<H4>Fichier mail.inc.php3</H4><FONT class=indexText>Le champ <I>popup</I> n\'existe pas. Veuillez contacter le webmaster</FONT>';
      include($repertorylevel.'include/error.inc.'.$e);
      exit;
    }

  //
  // Check for msg
  //
  $DB->query('SELECT id FROM '.MAIL_TABLE.' WHERE destinataire=\''.$memberid.'\' AND isread=\'no\' AND del!=\'dest\' ORDER BY date');

  while ($m = $DB->fetch_array())
    {
      $nonReadMail[] = $m;
    }
  $DB->free_result();
}

/************************************************************
 * @function : CheckMsg
 * @param    : none
 * @return   : no value
 * @action   : Check if non-read msg exist for current user,
 *             and display it if necessary
 **************************************************************/
function CheckMsg()
{
  //
  // Assert not a visitor
  //
  if (IsVisitor())
    {
      return;
    }

  //
  // Retrieve global infos
  //
  global $tMember, $memberid, $e, $lowestSectID, $nonReadMail, $lang;

  //
  // Check for msg
  //
  if ($tMember['popup'] == 'yes')
    {
      if (sizeof($nonReadMail))
	{
	  $msgNonRead = $nonReadMail[0];
	  CreateJScriptVar( array( 'e' => '\''.$e.'\'',
				   'id' => '\''.$msgNonRead['id'].'\'') )
	    ?>
<SCRIPT>
var parameters = "width=500,height=400,resizable=yes,scrollbars=yes";
var win = window.open("mail." + e + "?action=readmsg&idmsg=" + id, "readmsgAuto",parameters);
win.opener = null;
</SCRIPT>
    <?php
        }
    }

  //
  // Include nb of non-read msg
  //
  if ($nbMsg = sizeof($nonReadMail))
    {
      print('<FONT class=body><A href="mail.'.$e.'?idforum='.$lowestSectID.'">'.sprintf($lang['have_mail'], $nbMsg).'</A></FONT>');
    }
}

/****************************************************************
 * @function : MsgTo
 * @param    : member : id of the member the link will point to
 * @return   : no value
 * @action   : Insert a link allowing to send a msg to a person
 ***************************************************************/
$IsFunctionCreated = false;
function MsgTo($member, $text)
{
  global $e, $IsFunctionCreated;

  if (!$IsFunctionCreated)
    {
      $IsFunctionCreated = true;
      CreateJScriptVar( array( 'e' => '\''.$e.'\''));
	?>
<SCRIPT type="text/javascript">
<!--
function WriteTo(to)
{
  var parameters = "width=500,height=400,resizable=yes,scrollbars=yes";
  var win = window.top.open("mail." + e + "?action=postmsg&to=" + to, "postmsg",parameters);
  win.opener = null;
}
//-->
</SCRIPT>
	  <?php
	  }
    ?>
<A href="javascript:WriteTo('<?php echo $member;?>');"><?php echo $text;?></A>
<?php
}

/****************************************************************************************
 * @function : PostMsg
 * @param    : dest : whether pseudo (if string) or id (if not string)  of destinator
 *             author : string that contains author pseudo
 *             title : title of msg, not prepared to be inserted
 *             text : text of msg, not formated and prepared to be inserted
 * @return   : '' if no error occurs, and an error string otherwise
 * @action   : Post a msg
 ***************************************************************************************/
function PostMsg($dest, $author, $title, $text, $keepmsg)
{
  global $login, $erreur, $memberid, $lang, $DB;

  $erreur = '';

  //
  // Search for the destinator
  //
  if (is_string($dest))
    {
      //if may have more than one destinator
      $dest = explode(';', $dest);
      $nbDest = sizeof($dest);

      $dest = array_map('trim', $dest);
      $dest = join('\' OR pseudo=\'', $dest);

      $DB->query('SELECT id FROM '.MEMBRES_TABLE.' WHERE pseudo=\''.$dest.'\'');
    }
  else
    {
      $DB->query('SELECT id FROM '.MEMBRES_TABLE.' WHERE id=\''.$dest.'\' LIMIT 1');
      $nbDest = 1;
    }

  $destinators = array();
  while ($d = $DB->fetch_array())
    {
      $destinators[] = $d['id'];
    }
  $DB->free_result();

  //
  // Assert the destinator exists
  //
  if ((sizeof($destinators) != $nbDest) || !$nbDest)
    {
      $erreur = 'noDest';
      return 'noDest';
    }

  //
  // Prepare msg
  //
  $text = TextToHtml($text);
  $title = trim($title);

  //
  // Prevent empty title
  //
  if ($title == '')
    {
      $title = $lang['no_title'];
    }

  //
  // Insert msg
  //
  $del = $keepmsg ? 'no' : 'author';

  if (!$DB->query('INSERT INTO '.MAIL_TABLE." SELECT '','".str_replace("'","\'",$author)."','$memberid', pseudo,id,'$title','$text','".date('Y-m-d H:i:s')."','no','$del' FROM ".MEMBRES_TABLE.' WHERE id IN ('.join(',',$destinators).')'))
    {
      $erreur = 'postmsg';
    }

  //
  // return the erreur value
  //
  return $erreur;
}
?>
