<?php 
///////////////////////////
// $Header: d:\\cvs/forum82/forum/include/text.php3,v 1.6 2002/06/18 22:49:51 Administrateur Exp $
// text.php3   version 2.07
// FABRE Arnaud        2002
///////////////////////////

if (!defined('TEXT'))
{
  define('TEXT',true);
  
  /************************************************************************
   * @function : TruncSignature
   * @param    : a complete signature with separator and text
   * @return   : an array like that :
   *             - ['separator'] : a string with the separator
   *             - ['signature'] : a string with the rest of the signature
   ***********************************************************************/
  function TruncSignature($sign)
    {
      $signature = array();
      $sep = strpos($sign,"\n");
      $signature['separator'] = substr($sign, 0, $sep);
      $signature['signature'] = substr($sign, $sep+1);
      return $signature;
    }
  
  /******************************************************************************************
   * @function : TextToHtml
   * @param    : text : the text to convert
   * @return   : text converted into html :
   *             - special caracters are translated
   *             - urls are detected and converted with tag A
   *             - email are detected too
   *             - if possible, tag [b], [i], [u] are detected and converted to <B>, etc...
   *             - colorise line according to the number of > there is at their beginning
   ******************************************************************************************/
  function DetectTag(&$text, $tags, $replacement, $hasParameter)
    {
      $nbTags = sizeof($tags);

      if (($nbTags != sizeof($replacement)) || ($nbTags != sizeof($hasParameter)))
	{
	  return;
	}

      for ($i = 0; $i < $nbTags; $i++)
	{
	  if ($hasParameter[$i])
	    {
	      $text = preg_replace('#\['.$tags[$i].'=(.*)\](.*)\[/'.$tags[$i].'\]#isU', $replacement[$i], $text);
	    }
	  else
	    {
	      $text = preg_replace('#\['.$tags[$i].'\](.*)\[/'.$tags[$i].'\]#isU', $replacement[$i], $text);
	    }
	}
    }
  function RemoveTag(&$text, $tags, $Html, $hasParameter)
    {
      $nbTags = sizeof($tags);

      if (($nbTags != sizeof($Html)) || ($nbTags != sizeof($hasParameter)))
	{
	  echo 'erreur dans le fichier d\'appel';
	  return;
	}

      for ($i = 0; $i < $nbTags; $i++)
	{
	  //echo '<B>Tag : '.$tags[$i].'</B><BR>'.nl2br(htmlspecialchars($text)).'<HR>';
	  if ($hasParameter[$i])
	    {
	      $text = preg_replace('#'.$Html[$i].'#Us', '['.$tags[$i].'=\\1]\\2[/'.$tags[$i].']', $text);
	    }
	  else
	    {
	      $text = preg_replace('#'.$Html[$i].'#Us', '['.$tags[$i].']\\1[/'.$tags[$i].']', $text);
	    }
	  //echo '<B>Fin tag : '.$tags[$i].'</B><BR>'.nl2br(htmlspecialchars($text)).'<HR>';
	}
    }
  function TextToHtml($text)
    {
      //
      // Convert the text to html format
      // Special characters replacement
      //
      $text = removeHtmlChar($text);

      $tags         = array('b'  ,'i'   ,'u'   ,'size','color','url', 'url', 'img');
      $hasParameter = array(false, false, false, true, true,   false, true,  true);
      $replacement = array('<B>\\1</B>', '<I>\\1</I>', '<U>\\1</U>', '<SPAN style="font-size:\\1">\\2</SPAN>',
			   '<SPAN style="color:\\1">\\2</span>', '<A class=lienmsg href="\\1" target=_blank>\\1</A>',
			   '<A class=lienmsg target=_blank href="\\1">\\2</A>',
			   '<IMG border=0 alt="\\1" align=top src="\\2">');
      DetectTag($text, $tags, $replacement, $hasParameter);
      
      //detec img
      $text = preg_replace("#(?i)\[img\]((http://)?(\S*?))\[/img\]#","<IMG border=0 alt=\"\\1\" align=top src=\"http://\\3\">",$text);

      $text = eregi_replace(" {2,2}","&nbsp;&nbsp;",$text);
      //
      // Url search and addition
      //
      $text = preg_replace("#([\n (]|^|&gt;)([a-z0-9]{1,5})?://([^ \n\r]+[^, )\n\r])#i","\\1<A class=lienmsg href=\"\\2://\\3\" target=_blank>\\2://\\3</A>",$text);
      $text = eregi_replace("([\n >(]|^|&gt;)(www\.)([^, \n\r]+)","\\1<A class=lienmsg href=\"http://\\2\\3\" target=_blank>\\2\\3</A>",$text);
      
      //
      // E-mail search and addition
      //
      $text = preg_replace("#(?is)([ \n(]|^|&gt;)([_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)+)#","\\1<A class=lienmsg href=\"mailto:\\2\">\\2</A>",$text);

      //
      // Put in blue the lines which begins with ">>>"
      //
      $text = eregi_replace("(\n|^)((&gt;){3,3}[^\n]*)","\n<FONT class=level3>\\2</FONT>",$text);
      //
      // Put in red the lines which begins with ">>"
      //
      $text = eregi_replace("(\n|^)((&gt;){2,2}[^\n]*)","\n<FONT class=level2>\\2</FONT>",$text);
      //
      // Put in green the lines which begins with ">"
      //
      $text = eregi_replace("(\n|^)((&gt;){1,1}[^\n]*)","\n<FONT class=level1>\\2</FONT>",$text);
      
      //
      // Delete the abnormal new line added at the beginning
      //
      $text = eregi_replace("^\n(<FONT[^>]*>)","\\1",$text);

      //
      // Replace new line by <BR>
      $text = eregi_replace("\n","<BR>",$text);

      return $text;
    }

  /*********************************************************************
   * @function : HtmlToText
   * @param    : texte
   * @return   : this function does exactly the contrary of TextToHtml
   *             (NB : the images are completely remove, for now)
   *********************************************************************/
  function HtmlToText($texte)
    {
      //
      // Place a > at the beginning
      // (It's the only old line that is not preceded by <BR>)
      //
      $texte = '&gt;'.$texte;

      //
      // Replace the <BR>\n by \n>
      //
      $texte = eregi_replace("<BR>(\n)?","\n&gt;",$texte);
      //
      // Recreate [tag]
      //
      $tags         = array('b'  ,'i'   ,'u'   ,'size','color','url', 'url', 'img', 'img');
      $hasParameter = array(false, false, false, true, true,   false, true,  false,  true);
      $Html = array('<B>(.*)</B>', '<I>(.*)</I>', '<U>(.*)</U>', '<SPAN style="font-size:(.*)">(.*)</SPAN>',
		      '<SPAN style="color:(.*)">(.*)</span>', '<A class=lienmsg href="(.*)" target=_blank>(.*)</A>',
		    '<A class=lienmsg target=_blank href="(.*)">(.*)</A>',
		    '<IMG border=0 alt="(.*)" align=top src="(\\1)">',
		    '<IMG border=0 alt="(.*)" align=top src="(.*)">');

      RemoveTag($texte, $tags, $Html, $hasParameter);

      //
      // Delete all remaining tags
      //
      $texte = strip_tags($texte);
      return $texte;
    }

  /***************************************************
   * @function : ProcessTitle
   * @param    : title : string to treat
   * @return   : return title beginning with RE: and
   *             without the possible final NT
   ***************************************************/
  function ProcessTitle($title)
    {
      //
      // Remove NT
      //
      if (substr($title,-3,2) == 'NT')
	{
	  $title = substr($title,0,-4);
	}
      return $title;
    }
}
?>