#!/bin/sh
## add_traduc.sh for forum82 in /home/freddy/f82/forum/lang
##
## Made by (Freddy)
## Login   <freddi@ifrance.com>
##
## Started on  Fri Apr 16 19:45:55 2004 Freddy
##

if [ $# -le 0 ]; then
  echo "Usage: $0 [lang_section] id_string1 [id_string2 [id_string3 ...]]"
  exit 1
fi

## Does the first argument is a section ?
## if not, then we add the string to the default section
exists=0
for lang in *; do
  if [ -d "$lang" ]; then
    if [ -r "${lang}/lang_${lang}_$1.inc.php3" ]; then
      exists=1
      break;
    fi
  fi
done

## Check the result
if [ $exists -eq 1 ]; then
  ## the first argument is the name of a section : construct the section string
  ## and shift the first argument
  section=_$1
  shift
else
  ## the section does not exist => add to the default file, but get a confirmation before
  echo -n "The section $1 does not exist, do you want to add the string to the default file ? [N/y] ";
  while read answer; do
    if [ "$answer" = "" -o "$answer" = "N" -o "$answer" = "no" ]; then
      exit 1
    fi
    if [ "$answer" = "Y" -o "$answer" = "y" -o "$answer" = "yes" ]; then
      echo "Adding to the default file..."
      break;
    fi
    echo -n "Please answer yes or no... [N/y] "
  done
  section=
fi

## ok, now proceed to the translation addition
while [ $# -ne 0 ]; do
  echo "======== Adding translation for $1 ========"
  for lang in *; do
    if [ -d "$lang" ]; then
      filename="${lang}/lang_${lang}${section}.inc.php3"
      if [ -r "$filename" ]; then
	echo -n "Adding translation in $lang... "

	## first remove the trailing ?>
	grep -v "?>" "$filename" > "$filename.new"
	res=$?
	## then add the translation
	echo "\$lang${section}['$1'] = '$1'; // to translate" >> "$filename.new"
	## and restore the ?>
	echo "?>" >> "$filename.new"
	mv -f "$filename.new" "$filename"
	if [ $res -eq 0 ]; then
	  echo OK
	else
	  echo ERROR
	fi
      else
	## Error: one directory does not contains the needed file
	echo "No section $1 found in $lang, skipping"
      fi
    fi
  done
  ## Process the next translation to be added
  shift
done
exit 0
