<?php
//////////////////////////////////////////////////////////////
// $Header: d:\\cvs/forum82/forum/showmsg.inc,v 1.7 2002/06/18 00:02:32 Administrateur Exp $
// showmsg version 2.07
//  FABRE Arnaud     2001
// Contains all fonctions needed to show a thread
/////////////////////////////////////////////////////////////

//
// contains string that allow to format date with MySQL
//
include(dirname($_SERVER['SCRIPT_FILENAME']).'/include/date.inc.'.$e);

//
// each key contains the list of the answer's id of the message
// For exemple, $message[24] contains all the answer of the message number 24
//
$messages = array();

//
// contains all messages infos : author, title, date, ...
//
$data_messages = array();

//
// list of thread to show
//
$threadList = array();

//
// whether the current user can moderate or not
//
$bModerator = ($tMember['statut'] & ST_MOD)?true:false;

//
// Determine whether $t1 has to be before or after $t2
function sortThread($t1, $t2)
{
  global $data_messages;

  if ($t1['id'] == $t2['id'])
    {
      return 0;
    }

  if ($t1['istop'] == $t2['istop'])
    {
      return ($t1['id'] < $t2['id'])? 1:-1;
    }
  else
    {
      return ($t1['istop'] == 'yes') ? -1: 1;
    }
}

/*******************************************************************
 * @function     : ShowMessage
 * @param        : id is the msg's id of the msg that is to be shown
 * @return value : none
 * @action       : show the msg
 * @used var     : readTable
 *		   data_messages
 *******************************************************************/
function ShowMessage($id)
{
  //
  // $read and $_read are the code before and after the msg, in order to compute the aspect of the msg
  //
  $read = '';
  $_read = '';
  $unreadCode = '';

  global $bModerator, $idforum, $e, $memberid, $nbReplies, $data_messages, $lang, $threadList;

  //
  // sort of pointer to the current msg
  //
  $curMsg = $data_messages[$id];

  //
  // If the msg is marked as read
  //
  if (!$curMsg['isRead'])
    {
      //
      // Compute the aspect of the unread msg
      //
      $read = '<B>';
      $_read = '</B>';
      $unreadCode = ' name="a'.$id.'" id="a'.$id.'"';
    }

  ///////////////
  // msg title code + author (invariable)
  ///////////////

  //
  // Check if the msg is from the current user
  //
  $color = ($memberid==$curMsg['loginauteur'])?' class=own':'';

  //
  // Start creating the code
  //
  $code = '<LI>';
  $urlMsg = 'message.'.$e.'?action=show&amp;idmessage='.$id.'&amp;idforum='.$idforum;

  $curMsg['titre'] = removeHtmlChar($curMsg['titre']);

  //
  // if the msg is the first one, show the - img
  //
  if (($data_messages[$id]['id'] == $data_messages[$id]['fil']) && !defined('IN_SEARCH'))
    {
      $code .= '<IMG alt="'.$lang['show_hide'].'" src="img/moins.gif" width=7pt height=7pt id=img'.$id.' onclick="Swap(\''.$id.'\');">&nbsp;';
      if (isset($threadList[$id]) && ($threadList[$id]['istop'] == 'yes'))
	{
	  //	  $code .= '<A href="'.$urlMsg.'" target=message></A></B> ';
	  $curMsg['titre'] = '<B><FONT class=body>'.$lang['important_msg'].' :</FONT></B> '.$curMsg['titre'];
	  $color = ' class=importantMsg';
	}
    }

  //
  // Insert the title of the message
  //
  $code .= $read.'<A href="'.$urlMsg.'" target=message'.$color.$unreadCode.'>';
  $code .= $curMsg['titre'];
  $code .= '</A>'.$_read.'&nbsp;';

  $nt = substr($curMsg['titre'], -4, 4);
  if ( ($nt == '-NT-') || ($nt == '<NT>') || ($nt == '[NT]') || ($nt == '*NT*'))
    {
      $code .= '<A href="message.'.$e.'?action=fastpost&amp;idparent='.$id.'&amp;filparent='.($curMsg['fil']==$curMsg['id']?$id:$curMsg['fil']).'&amp;idforum='.$idforum.'" target=message class=fastpost>'.$lang['fast_reply'].'</A>&nbsp;&nbsp;';
    }

  //
  // link toward personnal card
  //
  $code .= '<A class=author href="member.'.$e.'?membreid='.$curMsg['loginauteur'].'&amp;idforum='.$idforum.'" target=_top>'
     . removeHtmlChar($curMsg['auteur'])
     . '</A>';

  //
  // show date
  //
  $code .= ' ('.format_date($curMsg['date']).')';

  //
  // show, if necessary, "delete"
  //
  if ($bModerator || $memberid == $curMsg['loginauteur'])
    {
      $code .= ' [<A href="#" onclick="javascript:return efface('.$id.');" class=gesfil target=message>'.$lang['delete'].'</A>]';
    }

  if ($curMsg['fil'] == $curMsg['id'])
    {
      $code .= '[<A href="javascript: mt('.$curMsg['id'].');" class=gesfil>'.$lang['thread_as_read'].'</A>]';
      if ($GLOBALS['config']->ShowNbAnswer)
	{
	  $code .= ' ('.$lang['answers'].' : '.(isset($nbReplies[$id])?$nbReplies[$id]:0).')';
	}
      if ($bModerator)
	{
	  $code .= ' [<A href="javascript:ManageThread('.$curMsg['id'].');" class=gesfil>'.$lang['thread_management'].'</A>]';
	}
    }

  $code .= "\n\t";
  echo $code;
}

/*****************************************************************
 * @function       : ShowThread
 * @param          : numthread : the id of the thread to be shown
 * @return         : no value
 * @action         : show the thread whose parent id is numthread
 * @used variables : messages
 *****************************************************************/
function ShowThread($numthread)
{
  global $idforum, $messages, $data_messages;

  $msgParent = $data_messages[$numthread]['msgparent'];

  //
  // open list in order to show the thread, only if the msg is the first answer of the parent msg
  //
  if (($messages[ $msgParent ] [0] == $numthread)
      || ($data_messages[$numthread]['id'] == $data_messages[$numthread]['fil']))
    {
      print('<UL');

      //is the parent msg the thread initiator ?
      if (($msgParent) && ($data_messages[ $msgParent ]['id'] == $data_messages[ $msgParent ]['fil']))
	{
	  echo ' id=thread'.$msgParent;
	}
      echo ">\n\t";
    }
  //
  // show the msg
  //
  ShowMessage($numthread);

  //
  // show the arborescence
  //
  for (;$nextfil = current($messages[$numthread]); next($messages[$numthread]))
    {
      ShowThread($nextfil);
    }

  //
  // End the list only if current msg is the last answer of the list or if this call is the start of the recursion
  //
  if (($messages[ $msgParent ] [sizeof($messages[ $msgParent ]) - 1] == $numthread)
      || ($data_messages[$numthread]['id'] == $data_messages[$numthread]['fil']))
    {
      print('</UL>'."\n");
    }
  return;
}

/******************************************************************************
 * @function : ShowTree
 * @param    : thread : array of thread to be shown
 * @return   : no value
 * @action   : construct the variables data_messages, readTable, messages and
 *	       uses them to show the complete structure of the tree
 *****************************************************************************/
function PreloadMsg($thread, &$nbUnreadMsg)
{
  global $threadList, $readTable, $memberid, $idforum, $nbReplies, $data_messages, $messages, $DB;

  //
  // Save thread list
  //
  $threadList = $thread;

  //
  // If nothing to show -> return
  if (!sizeof($thread))
    {
      return;
    }

  //
  // Initialise the messages-databases
  //
  $messages = array(); //initialization of the "message-database"
  $nbUnreadMsg = 0;

  $filQuery = '';
  while (list($id, $unused) = each($thread))
    {
      $filQuery .= $id.',';
    }
  $filQuery = substr($filQuery, 0, -1);

  $sql = 'SELECT f.id, msgparent, auteur, titre, loginauteur, f.fil, date, ISNULL(m.msg) AS isRead
FROM ('.PREF.'forum f
INNER JOIN '.PREF.'forum_data fd USING(id))
LEFT OUTER JOIN '.MSGLUS_TABLE.' m ON (f.id=m.msg AND m.section='.$idforum.' AND m.membre='.$memberid.')
WHERE f.fil IN ('.$filQuery.') AND f.section='.$idforum.'
ORDER BY f.id';

  //
  // Make the request
  //
  $DB->query($sql);

  //
  // message table construction
  //
  $nbReplies = array();
  while ($currentmsg = $DB->fetch_array())
    {
      //
      // Add the msg as a response of another msg
      //
      $messages[$currentmsg['msgparent']][] = $currentmsg['id'];

      //
      // Add the new message as a potential new tree
      //
      $messages[$currentmsg['id']] = array(); //add the new msg as a potential new tree

      //
      // Save the info of the msg (date, author, title, ...)
      //
      $data_messages[$currentmsg['id']] = $currentmsg;
      if (isset($nbReplies[$currentmsg['fil']]))
	{
	  $nbReplies[$currentmsg['fil']]++;
	}
      else
	{
	  $nbReplies[$currentmsg['fil']] = 0;
	}

      if (!$currentmsg['isRead'])
	{
	  $nbUnreadMsg++;
	}
    }
  $DB->free_result();
}

function ShowTree()
{
  global $threadList, $data_messages;
  //
  // Show each thread
  //
  reset($threadList);
  for (; $numthread = key($threadList); next($threadList))
    {
      ShowThread($numthread);

      //
      // Make the server send the processed part of the page
      //
      flush();
    }

  //
  // Free a few memory
  //
  unset($GLOBALS['data_messages']);
  unset($GLOBALS['messages']);
}
?>
