<?php 
///////////////////////////////
// $Header: d:\\cvs/forum82/forum/upd/updv25.php3,v 1.1 2002/06/18 00:39:08 Administrateur Exp $
// Update Script to 2.5
// FABRE Arnaud            2002
///////////////////////////////

$error = false;

function my_array_map($f, $a)
{
  reset($a);
  while (list($unused, $value) = each($a))
    {
      $f($value);
    }
}

function RenameTable($table)
{
  global $error, $debug, $DB;

  if (!$error)
    {
      if (isset($debug) && ($debug == 1))
	{
	  echo '<BR><HR><SPAN style="color:red">DEBUG :</SPAN> ALTER TABLE '.$table.' RENAME '.PREF.$table;
	}
      
      //
      // Do not try to update name if an error already occured
      //
      if (!$DB->query('ALTER TABLE '.$table.' RENAME '.PREF.$table))
	{
	  echo $DB->DoError(false);
	  $error = true;
	}
    }
}

function UpdateFlagMember($member)
{
  global $error, $DB;

  if (!$error)
    {
      echo '<BR>Converting member <I>'.htmlspecialchars($member['login']), '</I>... ';
      flush();
      
      $query = 'UPDATE '.FLAGS_TABLE.' SET membre2='.$member['id'].' WHERE membre=\''.$member['login'].'\'';
  
      //
      // Do not try to update name if an error already occured
      //
      if (!$DB->query($query))
	{
	  $error = true;
	  echo $DB->DoError(false);
	}
      else
	{
	  echo '<BR><HR><SPAN style="color:green">done</SPAN>';
	  flush();
	}
    }
}
  
function ExeQuery($query)
{
  global $error, $debug, $DB;

  if (!$error)
    {
      if (isset($debug) && ($debug == 1))
	{
	  echo '<BR><HR><SPAN style="color:red">DEBUG :</SPAN> '.nl2br(str_replace('  ', '&nbsp;&nbsp;', htmlspecialchars($query)));
	}
      
      //
      // Do not try to execute the query if an error already occured
      //
      if (!$DB->query($query))
	{
	  $error = true;
	  echo $DB->DoError(false);
	}
    }
}

function UpdateForum($etape)
{
  global $error, $numforum, $DB;

  //contains the offset that will be applicated on the $etape var.
  $offset = 1;

  switch ($etape)
    {
      // Swith cases
      //
    case 0:
      {
	// Update forum prefix (etape 0)
	//
	echo '<B>Step 0 :</B> Modifying table prefix... ';
	flush();

	$tables = array('fil', 'flags', 'mail', 'membres', 'msglus', 'section');
	my_array_map('RenameTable', $tables);
	
	if (!$error)
	  {
	    echo '<BR><HR><SPAN style="color:green">done</SPAN><BR>';
	  }
	break;
      }
    case 1:
      {
	// Update structure tables
	//
	echo '<B>Step 1 :</B> Upgrading table structures... ';
	flush();
	$i = 0;
	$q = array();
	$q[$i++] = 'ALTER TABLE '.FIL_TABLE.'
                      ADD INDEX att(att),
                      MODIFY fil MEDIUMINT UNSIGNED DEFAULT \'0\' NOT NULL';

	// membre2 value will be set after, then renamed to membre (the old columns would have been deleted)
	$q[$i++] = 'ALTER TABLE '.FLAGS_TABLE.'
                      DROP PRIMARY KEY,
                      DROP id,
                      ADD membre2 SMALLINT(5) unsigned NOT NULL default \'0\' AFTER msg,
                      MODIFY msg MEDIUMINT UNSIGNED DEFAULT \'0\' NOT NULL ';

	$q[$i++] = 'ALTER TABLE '.MAIL_TABLE.'
                      DROP INDEX id,
                      ADD INDEX destinataire(destinataire),
                      ADD INDEX authorid(authorid)';

	$q[$i++] = 'ALTER TABLE '.MEMBRES_TABLE.'
                     MODIFY password varchar(32) NOT NULL default \'\',
                     ADD activation_key varchar(32) NOT NULL default \'\' AFTER password,
                     ADD tpp int(10) unsigned NOT NULL default \'10\' AFTER nt,
                     ADD keepmail enum(\'yes\',\'no\') NOT NULL default \'yes\' AFTER email,
                     MODIFY skin varchar(40) NOT NULL default \'default/skin.css|default\',
                     ADD lang char(2) NOT NULL default \'fr\',
                     DROP INDEX id';

	//Impose the default skin, unless the forum will show errors
	//and reset the password
	$q[$i++] = 'UPDATE '.MEMBRES_TABLE.' SET skin=\'default/skin.css|default\', password=\'\'';
	
	$q[$i++] = 'ALTER TABLE '.MSGLUS_TABLE.'
                     ADD INDEX msg(msg),
                     ADD INDEX message (membre,msg,section),
                     MODIFY fil MEDIUMINT UNSIGNED DEFAULT \'0\' NOT NULL,
                     MODIFY msg MEDIUMINT UNSIGNED DEFAULT \'0\' NOT NULL,
                     MODIFY membre SMALLINT UNSIGNED DEFAULT \'0\' NOT NULL';
	
	$q[$i++] = 'ALTER TABLE '.SECTION_TABLE.' ADD acces2 tinyint(3) unsigned NOT NULL default \'0\' AFTER name';

	//Update forum access states
	$q[$i++] = 'UPDATE '.SECTION_TABLE.' SET acces2=2 WHERE acces=\'public\'';

        $q[$i++] = 'UPDATE '.SECTION_TABLE.' SET acces2=1 WHERE acces=\'private\'';
	$q[$i++] = 'ALTER TABLE '.SECTION_TABLE.'
                     DROP acces,
                     CHANGE acces2 acces tinyint(3) unsigned NOT NULL default \'0\',
                     ADD post mediumint(8) unsigned NOT NULL default \'0\'';

	//Create new forums table
	$q[$i++] = 'CREATE TABLE '.THREAD_TABLE.' (
                      id mediumint(8) unsigned NOT NULL default \'0\',
                      section tinyint(3) unsigned NOT NULL default \'0\',
                      istop enum(\'yes\',\'no\') NOT NULL default \'no\',
                      PRIMARY KEY  (id),
                      KEY section (section)
                    ) TYPE=MyISAM;';

	$q[$i++] = 'CREATE TABLE '.PREF.'forum (
                      id MEDIUMINT(5) unsigned NOT NULL auto_increment,
                      fil MEDIUMINT(5) unsigned NOT NULL default \'0\',
                      msgparent MEDIUMINT(5) unsigned NOT NULL default \'0\',
                      loginauteur smallint unsigned  NOT NULL default \'0\',
                      section tinyint(3) unsigned NOT NULL default \'0\',
                      PRIMARY KEY  (id),
                      KEY fil (fil),
                      KEY section (section)
                     )';

	$q[$i++] = 'CREATE TABLE '.PREF.'forum_data (
                     id MEDIUMINT(8) unsigned NOT NULL default \'0\',
                     date datetime NOT NULL default \'0000-00-00 00:00:00\',
                     auteur varchar(20) NOT NULL default \'\',
                     titre varchar(128) NOT NULL default \'\',
                     texte longtext NOT NULL,
                     ip int(10) unsigned NOT NULL default \'0\',
                      PRIMARY KEY  (id)
	  )';
	my_array_map('ExeQuery', $q);
	
	if (!$error)
	  {
	    echo '<BR><HR><SPAN style="color:green">done</SPAN><BR>';
	  }
	break;
      }
    case 2:
      {
	// Update flags table
	//
	echo '<B>Step 2 :</B> Converting flags table... ';
	flush();

	// List members
	//
	$DB->query('SELECT id, login FROM '.MEMBRES_TABLE);
	$member = array();

	while ($m = $DB->fetch_array())
	  {
	    $member[] = array('id' => $m['id'], 'login' => $m['login']);
	  }
	$DB->free_result();
	
	// Update them
	//
	my_array_map('UpdateFlagMember', $member);
	echo '<BR>';

	// Update table
	//
	$query = array('ALTER TABLE '.FLAGS_TABLE.'
                         DROP membre,
                         CHANGE membre2 membre smallint(5) unsigned NOT NULL default \'0\',
                         ADD INDEX membre(membre),
                         ADD INDEX section(section)');
	my_array_map('ExeQuery', $query);

	break;
      }
    case 3:
      {
	// Converting forum messages
	//
	if (!isset($numforum))
	  {
	    $numforum = 0;
	  }

	// Retrieve max(id)
	$DB->query('SELECT MAX(id) AS max FROM '.PREF.'forum');
	$maxId = $DB->fetch_array();
	$DB->free_result();
	$maxId = $maxId['max'];
	if (!isset($maxId))
	  {
	    $maxId = 0;
	  }
	//retrieve forum
	$idforumR = $DB->query('SELECT id FROM '.SECTION_TABLE.' LIMIT '.$numforum.', 1');

	//process the insertion if needed
	if ($DB->num_rows())
	  {
	    echo '<B>Step 3 :</B> Converting messages data (forum '.$numforum.') ... ';
	    flush();

	    $idforum = $DB->fetch_array();
	    $idforum = $idforum['id'];
	    $DB->free_result();

	    $query = array();

	    //List all query needed to convert the forum
	       // ==> Reinsertion of messages
	    $query[] = 'INSERT INTO '.PREF.'forum
                        SELECT id + '.$maxId.',
                               IF (fil=-1,id,fil) + '.$maxId.',
                               msgparent + '.$maxId.',
                               loginauteur,
                               '.$idforum.'
                        FROM forum'.$idforum;
	    $query[] = 'INSERT INTO '.PREF.'forum_data
                        SELECT id + '.$maxId.',
                               date,
                               auteur,
                               titre,
                               texte,
                               \'\'
                        FROM forum'.$idforum;
	       // ==> Update others tables
	    $query[] = 'UPDATE '.FIL_TABLE.' SET fil=fil + '.$maxId.' WHERE section='.$idforum;
	    $query[] = 'UPDATE '.FLAGS_TABLE.' SET msg=msg + '.$maxId.' WHERE section='.$idforum;
	    $query[] = 'UPDATE '.MSGLUS_TABLE.' SET fil=fil + '.$maxId.', msg=msg + '.$maxId.' WHERE section='.$idforum;

	    // Run requests
	    my_array_map('ExeQuery', $query);
	    
	    if (!$error)
	      {
		echo '<BR><HR><SPAN style="color:green">done</SPAN><BR>';
	      }
	    
	    // we have to stay at the same step
	    //
	    $offset = 0;
	    $numforum++;
	  }
	else
	  {
	    //All forums have been converted
	    $DB->free_result();

	    echo '<B>Step 3 end :</B> Finalizing conversion of messages data... ';

	    $query = array('UPDATE '.PREF.'forum SET msgparent=0 WHERE fil=id');
	    my_array_map('ExeQuery', $query);

	    if (!$error)
	      {
		echo '<BR><HR><SPAN style="color:green">done</SPAN><BR>';
	      }
	  }
	break;
      }
    case 4:
      {
	echo '<B>Step 4 :</B> Registering thread\'s message header and counting messages...';
	flush();

	$query = array('INSERT INTO '.THREAD_TABLE.' SELECT id, section, \'no\' FROM '.PREF.'forum WHERE msgparent=0');

	$DB->query('SELECT IF(f.id IS NULL,0,COUNT(*)) AS nbPosts, s.id FROM '.SECTION_TABLE.' s LEFT OUTER JOIN '.PREF.'forum f ON (s.id=f.section) GROUP BY f.section');
	while ($p = $DB->fetch_array())
	  {
	    $query[] = 'UPDATE '.SECTION_TABLE.' SET post='.$p['nbPosts'].' WHERE id='.$p['id'];
	  }

	my_array_map('ExeQuery', $query);

	if (!$error)
	  {
	    echo '<BR><HR><SPAN style="color:green">done</SPAN><BR>';
	  }
	break;
      }
    case 5:
      {
	// Deleting old tables
	//
	echo '<B>Step 5 :</B> Deleting old tables... ';
	flush();
	
	//retrieve id and construct query
	$DB->query('SELECT id FROM '.SECTION_TABLE);
	$query = array();
	while ($id = $DB->fetch_array())
	  {
	    $query[] = 'DROP TABLE forum'.$id['id'];
	  }

	// Delete tables
	//
	my_array_map('ExeQuery', $query);
	
	if (!$error)
	  {
	    echo '<BR><HR><SPAN style="color:green">done</SPAN><BR>';
	  }
	break;
      }
    default:
      {
	// Default case
	//
	global $end;
	$end = 1;
	break;
	}
    }
       
  return $offset;
}

// Retrieve globals parameters
 $repertorylevel = '../';
 require($repertorylevel.'extension.inc');
 require($repertorylevel.'config.'.$e);
 require($repertorylevel.'include/constants.inc.'.$e);
 require($repertorylevel.'include/tables.inc.'.$e);
 require($repertorylevel.'include/db/mysql.inc.'.$e);

if (PHP_VERSION >= '4.1.0')
{
  @import_request_variables('gpc');
}

$DB = new CMysql();

//connect to mysql db
$DB->connect($config->host, $config->mysql_account, $config->mysql_password, $config->mysql_db, $config->persistence);

if (!isset($etape))
{
  $etape = -1;
}

$error = false;

echo '<HTML>
  <HEAD>
    <TITLE>Update from Version 2.07 to 2.5</TITLE>
    <LINK rel="stylesheet" type="text/css" href="../membres/install.css">
  </HEAD>
  <BODY>';

if ($etape == -1)
{
    echo ''.'
    <H3>Forum82 upgrade script</H3>
    <P>This script will upgrade Forum82 from version 2.07 to version 2.5.</P>
    <P><SPAN style="color:red">Warning !!</SPAN> If your version is not 2.07, DO NOT run
    this script, unless imprevisible dommages will be made to your database !!</P><BR>
    <P>If you want to upgrade your installation, please read this before :<BR>
    <I>Due to a change in the way the passwords are crypted, you will not be able to
     log onto the forum after the installation. In order to retrieve your account,
    you\'ll have to use the lost password page (forum/lostpassword.php3). MAKE
    SURE YOU HAVE FILLED YOU EMAIL ADDRESS !! Otherwise, you\'ll can\'t retrieve
    it. If your host does not allow you to send mail, then an admin have to re-set
    passwords of each member after installation. This admin have the ability to
    retrieve its password using this page : <A href="upd/adminpass.'.$e.'" target="_blank">
    upd/adminpass.'.$e.'</A>.</I></P><BR>
    <B><SPAN size=medium>It is recommended to make a backup of your database before upgrading.</FONT></B><BR><BR>
    <A href="updv25.'.$e.'?etape=0">Proceed to upgrade &gt;&gt;</A><BR><BR>
    If you want to proceed to upgrade in debug mode (display all queries), use this link :<BR>
    <A href="updv25.'.$e.'?etape=0&amp;debug=1">Proceed to upgrade in debug mode&gt;&gt;</A>';
}
else
{
  $etape += UpdateForum($etape);
  $DB->disconnect();
  
  if ($error)
    {
      echo '<BR><HR><SPAN style="color:ref">An error has occured while upgrading.</SPAN>';
    }
  else
    {
      if (isset($end) && ($end==1))
	{
	  echo '<P>Update complete !!</P>
<P>You should now retrieve your password by email <A href="../lostpassword.'.$e.'">here</A> or directly by form <A href="adminpass.'.$e.'">here</A>';
	}
      else
	{
	  $addparam = isset($numforum) ? '&numforum='.$numforum : '';
	  $addparam .= isset($debug) ? '&debug=1':'';
	  echo '<SCRIPT type="text/javascript">
<!--
  setTimeout(\'document.location.href=\\\'updv25.'.$e.'?etape='.$etape.$addparam.'\\\'\', 5000);
//-->
</SCRIPT>
<HR>5 seconds before next step, please wait...';
	}
    }
}
echo '</BODY></HTML>';
?>