<?php 
/////////////////////////////
// updtool.php3  version 2.07
// FABRE Arnaud          2002
/////////////////////////////

$repertorylevel = dirname($_SERVER['SCRIPT_FILENAME']).'/';
include($repertorylevel.'extension.inc');

if (@file_exists('config.'.$e) && !isset($configUploaded)) //the forum is already installed or is currently updated
{
  include('extension.inc');

  //
  // Prevent error while including forum82lib.php3
  //
  define('FORUM82LIB', true);
  $repertorylevel = '';
  include('include/constants.inc.'.$e);
  include('config.'.$e);

  // $mysql_link = mysql_connect($config->host,$config->mysql_account,$config->mysql_password) or die ('Connexion au serveur de donnes impossible');

  define('INSTALLED', true);
}
else
{
  if (isset($configUploaded))
    {
      include('config.'.$e);
    }
  define('INSTALLED', false);
}

//
// First, dclare the object that are used to store info about versions
//
$versions = Array();
$currentVersion = '';

// New
// Puts all the mysql query in an array
//
function RetrieveSQLQueries($file)
{
  global $SQLQuery;

  $f = file($file);
  $f = join('', $f);

  $str_len = strlen($f);

  $i = 0;
  $in_string = false;
  $is_escaped = false;
  $start_string = '';
  $in_comment = false;
  $current_line = '';
  while ($i <= $str_len)
    {
      if ($in_string)
	{
	  if ($f[$i] == $start_string && !$is_escaped)
	    {
	      $start_string = '';
	      $in_string = false;
	    }
	  else if ($f[$i] == '\\')
	    {
	      $is_escaped = !$is_escaped;
	    }
	  $current_line .= $f[$i];
	  $i++;
	}
      else
	{
	  if ($f[$i] == '\'' || $f[$i] == '"')
	    {
	      $in_string = true;
	      $start_string = $f[$i];
	      $current_line .= $f[$i];
	      $i++;
	    }
	  else if ($f[$i] == ';')
	    {
	      $SQLQuery[] = trim($current_line);
	      $current_line = '';
	      $i++;
	    }
	  else if ($f[$i] == '#')
	    {
	      $i = strpos($f, "\n", $i);
	      if (!$i)
		{
		  $i = $str_len;
		}
	      else
		{
		  $i++;
		}
	    }
	  else
	    {
	      $current_line .= $f[$i];
	      $i++;
	    }
	}
    }
/*  $SQLQuery = file($file);
    while (list($key, $query) = each($SQLQuery))
    {
    $query = trim($query);

    //Remove comments and empty lines
    if ( ($query == '') || (substr($query, 0, 1) == '#'))
    {
    unset($SQLQuery[$key]);
    }
    else
    {
    $SQLQuery[$key] = $query;
    }
    }*/
}


/********************************
 * Function that create the var. needed to recreate
 * the config file using existing values or, if
 * they does not exist, putting default values
 ********************************/
function CreateConfigValue()
{
  global $config, $urlbaseModif, $hostModif, $mysql_accountModif, $mysql_passwordModif, $mysql_dbModif, $forumTitleModif, $enterMsgModif, $useSkinModif, $autoReloadModif, $ShowNbAnswerModif, $gZipCompressionModif;

  $urlbaseModif = !isset($config->urlbase)?'http://localhost/': $config->urlbase;
  $hostModif = isset($config->host)? $config->host : 'localhost';
  $mysql_accountModif = isset($config->mysql_account)? $config->mysql_account : '';
  $mysql_passwordModif = isset($config->mysql_password)? $config->mysql_password : '';
  $mysql_dbModif = isset($config->mysql_db)? $config->mysql_db : 'lesraouls';
  $forumTitleModif = isset($config->forumTitle)? $config->forumTitle : 'Forum82';
  $enterMsgModif = isset($config->enterMsg)? $config->enterMsg : 'Bienvenue sur les forums';

  //Boolean value
  $useSkinModif = isset($config->useSkin) ? ($config->useSkin?'true':'false') : 'true';
  $autoReloadModif = isset($config->autoReload)? ($config->autoReload?'true':'false') : 'false';
  $ShowNbAnswerModif = isset($config->ShowNbAnswer)? ($config->ShowNbAnswer?'true':'false') : 'true';
  $gZipCompressionModif = isset($config->gZipCompression)? ($config->gZipCompression?'true':'false') : 'true';
}

//
// Add a new version, and set it the current version
//
function DeclareVersion($numVersion, $comment)
{
  global $versions, $currentVersion;
  $versions[$numVersion] = Array('comment' => $comment);
  $currentVersion = $numVersion;
}

//===================================================
//Add a file that was modified in the current version
//===================================================
function AddFileModif($fileName, $path = "forum/", $reason = "No reason specified")
{
  global $versions, $currentVersion;
  $versions[$currentVersion]['files'][] = array("modified" => true, "name" => $fileName, "path" => $path, "reason" => $reason);
}

//=================
//Register new file
//=================
function AddNewFile($fileName, $path = "forum/", $reason = "No reason specified")
{
  global $versions, $currentVersion;
  $versions[$currentVersion]['files'][] = array("modified" => false, "name" => $fileName, "path" => $path, "reason" => $reason);
}

//===========================================
//construct the list of updated and new files
//===========================================
$updFiles = array();
$newFiles = array();
$SQLquery = array();
$comments = '';
function CompileListFile()
{
  global $updFiles, $newFiles, $SQLquery, $comments, $versions;

  while (list($v, $versObject) = each($versions))
    {
      $comments .= "<B>$v</B>:<BR>$versObject[comment]<BR>"; //add comment
      while (list($q, $query) = @each($versObject["query"])) //add query
	{
	  $SQLquery[] = $query;
	}
      while (list($m, $file) = @each($versObject["files"]))
	{
	  if ($file["modified"]) //modifieffile
	    {
	      $updFiles[$file['name']]['name'] = $file['name'];
	      $updFiles[$file['name']]['path'] = $file['path'];
	      $updFiles[$file['name']]['reason'] .= "<B>$v:</B><BR>".$file['reason']."<BR>";
	    }
	  else //new file
	    {
	      $newFiles[$file['name']]['name'] = $file['name'];
	      $newFiles[$file['name']]['path'] = $file['path'];
	      $newFiles[$file['name']]['reason'] = "<B>$v:</B><BR>".$file['reason']."<BR>";
	    }
	}

    }
  ksort($updFiles);
  ksort($newFiles);
}

//========================================================================================
//--------------Start registration of versions--------------------------------------------
if (!isset($versionUpdated))
{
  if (INSTALLED)
    {
      $versionUpdated = FORUM82_VERSION;
    }
  else
    {
      $versionUpdated = 0;
    }
}

$includeFile = str_replace(".","_",$versionUpdated);
if (INSTALLED && !@file_exists('upd/'.$includeFile.'.inc.'.$e) && !isset($step)
    && !isset($configUploaded))
{
  print("<HTML><HEAD><TITLE>Numro de version erron</TITLE>\n");
  print('<LINK rel="stylesheet" type="text/css" href="membres/install.css">');
  print("</HEAD><BODY><FONT color=red><B>Votre version de Forum82 est dj  jour</B></FONT>");
  print('</BODY></HTML>');
  mysql_close();
  exit;
}



if (INSTALLED)
{
  include("upd/$includeFile.inc.$e");
}
CompileListFile();

//------------------End registration-------------------------------
//=================================================================
//----------------
if (isset($action) && $action == 'update')
{
?>
<HTML>
<HEAD>
<TITLE>Mise  jour de Forum82 en cours...</TITLE>
<LINK rel="stylesheet" type="text/css" href="membres/install.css">
</HEAD>
<BODY>

<?php 
  reset($versions);
  if (!isset($step))
    {
      $step = 0;
    }

  $erreur = '';

  //
  // Step 0 : update config file
  //
  if ($step == 0)
    {
      print('Mise  jour du fichier de configuration...');
      flush();

      CreateConfigValue();
      define('FORUM82LIB', true); //allow inclusion of file
      include('admin/createconfig.'.$e);

      if ($erreur != '')
	{
	  print('<FONT color=red>Erreur !!</FONT><BR>');
	  print('Nom de l\'erreur : '.$erreur.'<BR>');
	  print('Il est possible qu\'il faille requrir  une mise  jour manuelle du forum');
	}
      else
	{
	  print('<FONT class=green>TERMINE</FONT><BR>');
	}
    }

  //
  // Position the versions array to the version we want to process
  //
  $i = $step;
  for (; $i > 0; $i--)
    {
      next($versions);
    }
  //
  // find the next version where we have to do something
  //
  while (!@file_exists('upd/'.str_replace('.', '_', key($versions)) . '.sql')
	 && !@file_exists('upd/'.str_replace('.', '_', key($versions)) . '_code.' . $e))

    {
      if (!next($versions)) // if we have reached the last version
	{
	  $updated = true;
	  break;
	}
      else
	{
	  prev($versions);
	  print('Mise  jour vers la version <FONT color=green>'. key($versions). '</FONT> effectue<BR>');
	  next($versions);
	  flush();
	  $updated = false;
	  $step++;
	}
    }

  //
  // We have to do SQL query or execute code to update
  //
  if (current($versions))
    {
      print('Mise  jour vers la version <FONT color=green>'.key($versions).'</FONT>...');

      if (isset($substep) && $substep != 0) // in case we can't perform the update in one step (for time reason)
	{
	  print('Etape '.$substep.' ...' );
	}
      else
	{
	  $substep = 0;
	}

      flush();
      $canContinue = true;
      //if substep != 0, its that we already have executed SQLQueries
      if (@file_exists('upd/'.str_replace('.','_', key($versions)) . '.sql') && $substep == 0)
	{
	  $canContinue = false;
	  //
	  // Do SQL query update
	  //
	  RetrieveSQLQueries( 'upd/'.str_replace('.', '_', key($versions)) . '.sql');
	  reset($SQLQuery);
	  while (list($key, $sql) = each($SQLQuery))
	    {
	      if (!mysql_query($sql))
		{
		  print('<FONT color=red>ERREUR : mise  jour de la base de donnes</FONT><BR>');
		  $erreur = 'sql';
		  break;
		}
	      else
		{
		  echo "<BR>Requte : ".htmlentities($sql);
		}
	    }
	}

      //
      // Do Update Code
      //
      if ($canContinue)
	{
	  include('upd/'. str_replace('.','_', key($versions)) . '_code.' . $e);
	}
      if ($erreur == '')
	{
	  print('<FONT color=green>TERMINE</FONT><BR>');
	  flush();
	}


      //
      // We have do the maximum for this pass, continue the update with another request
      //
      if ($canContinue)
	{
	  $step++;
	  $substep = 0;
	}
      else
	{
	  $substep++;
	}
      print('<BR>La mise  jour n\'est pas termine, veuillez patienter...<BR><BR>Ne pas faire de refresh !!'."\n");
      print('<SCRIPT>'."\n".'setTimeout(\'document.location.href=\\\'updtool.'.$e.'?action=update&step='.$step.'&substep='.$substep.'&versionUpdated='.$versionUpdated.'\\\';\', 10000);'."\n".'</SCRIPT>');
    }
  else
    {
      print('Mise  jour effectue avec succs !! Il est recommand d\'aller sur la page de <A href="admin.'.$e.'?formaction=seeconfig">configuration du forum</A>.');
    }
  ?>
</BODY>
</HTML>
<?php 
    exit;
}
if (isset($action) && $action == 'install')
{
  $repertorylevel = '';
  define('FORUM82LIB', true);

  $erreur = '';

  if (!isset($configUploaded))
    {
      include('admin/createconfig.'.$e);
    }

  if (($erreur != '' || 1) && (!isset($configUploaded) && $configUploaded != 'true'))
    {
      echo "Erreur lors de la cration du fichier de configuration : impossible de crer un fichier";
      print "Uploadez un fichier nomm config.inc.$e dans le dossier forum/ dont le contenu est inscrit ci-dessus, puis cliquez <A href=\"updtool.$e?action=install&configUploaded=true&loginAdmin=$loginAdmin&pass=$pass\">ici</A>. Attention !! Le fichier config.inc.$e ne doit pas comporter d'espace avant et aprs les tags <?php  et ?>, sinon, le forum ne fonctionnera pas correctement !<BR><BR>";
      print nl2br(str_replace(' ','&nbsp;',htmlentities($file)));
      exit;
    }
  RetrieveSQLQueries('upd/install.sql');

  if (isset($configUploaded))
  {
    //connect to sql server
    $mysql_link = mysql_connect($config->host,$config->mysql_account,$config->mysql_password) or die ("Connexion au serveur de donnes impossible");
    //Ouverture de la base de donnes
    mysql_select_db($config->mysql_db,$mysql_link) or die("Ouverture de la base de donnes impossible");
  }
  else
  {
    //connect to sql server
    $mysql_link = mysql_connect($hostModif,$mysql_accountModif,$mysql_passwordModif) or die ("Connexion au serveur de donnes impossible");
    //Ouverture de la base de donnes
    mysql_select_db($mysql_dbModif,$mysql_link) or die("Ouverture de la base de donnes impossible");
  }

  reset($SQLQuery);
  while (list($key, $sql) = each($SQLQuery))
    {
      if (!mysql_query($sql))
	{
	  print('<FONT color=red>ERREUR : mise  jour de la base de donnes</FONT><BR>');
	  $erreur = 'sql';
	  exit;
	}
    }

  include('upd/install.inc.'.$e);

  echo "L'installation s'est bien droule. Vous devriez diter les paramtres du forum et effacer ce fichier et le dossier upd.";

  mysql_close($mysql_link);
  exit;
}
?>
<HTML>
<HEAD>
<LINK rel="stylesheet" type="text/css" href="membres/install.css">
<TITLE>Forum82</TITLE>
</HEAD>
<BODY>
<?php 
if (INSTALLED)
{
  $code = '<H4>Mise  jour de Forum82</H4>';
  $code .= 'Cette page facilite la mise  jour de Forum82 en vous indiquand quels fichiers mettre  jour, et en ralisant  votre place les requtes mysql ncessaires  cette mise  jour.<BR><BR>';
}
else
{
  $code = '<H4>Installation de Forum82</H4>';
  $code .= 'Bienvenue sur la page d\'installation de Forum82. Afin de procder  l\'installation, il vous faut tout d\'abord uploader votre fichier, veuillez complter les champs suivant :<BR><BR>';
}
print($code);

if (INSTALLED)
{
  if (isset($fileUpdated) && $fileUpdated == "true")
    print("La version dclare des fichiers de Forum82 est la version <B>".FORUM82_VERSION."</B>.<BR>Forum82 est donc normalement mis  jour.<BR><BR>");
  else print("Vous tes actuellement  la version <B>$versionUpdated</B>.<BR>Vous devez rcuprez la liste des fichiers  mettre  jour qui apparat ci-dessous. Ensuite, cliquez sur le bouton \"Procder  la mise  jour\".<BR><BR>");
    ?>
<TABLE style="width:90%" cellspacing=0 align=center>
<TR>
<TH colspan=3>Infos de mises  jour pour la version <?php echo $currentVersion;?> de Forum82</TH>
</TR>
<?php 
//Insert the result in a table
print("<TR><TD width=20%>Commentaires :</TD><TD colspan=2 style=\"text-align=left;\">$comments</TD></TR>");
?>
<TR>
	<TH colspan=3>Fichiers  mettre  jour</TH>
</TR>
<TR>
	<TD><B><I>Nom des fichiers</I></B></TD>
	<TD><B><I>Emplacement</I></B></TD>
	<TD><B><I>Raison de la modification</I></B></TD>
</TR>
<?php 
   if (sizeof($updFiles) == 0)
     print("<TR><TD colspan=3><I>Pas de fichiers  mettre  jour</I></TD></TR>\n");
   else
     {
       while (list($f, $file) = each($updFiles))
	 {
	   print("<TR><TD>$file[name]</TD><TD>$file[path]</TD><TD>$file[reason]</TD></TR>\n");
	 }
     }
?>
<TR>
	<TH colspan=3>Nouveaux fichiers</TH>
</TR>
<TR>
	<TD><B><I>Nom des fichiers</I></B></TD>
	<TD><B><I>Emplacement</I></B></TD>
	<TD><B><I>Raison de l&#39;ajout du fichier</I></B></TD>
</TR>
<?php 
if (sizeof($newFiles) == 0)
  {
    print("<TR><TD colspan=3><I>Pas de nouveaux fichiers</I></TD></TR>\n");
  }
 else
   {
     while (list($f, $file) = each($newFiles))
       {
	 print("<TR><TD>$file[name]</TD><TD>$file[path]</TD><TD>$file[reason]</TD></TR>\n");
       }
   }
?>
</TABLE><BR>
<FORM action="updtool.<?php echo $e;?>" method=post>
<INPUT type=hidden name=action value=update>
<INPUT type=hidden name=step value=0>
<INPUT type=hidden name=versionUpdated value="<?php echo str_replace('.', '_', FORUM82_VERSION);?>">
<B>Procdure de mise  jour :</B> Il vous faut tout d'abord lire EN ENTIER le contenu du tableau ci-dessus, puis uploader tous les fichiers mentionns. Ces fichiers se trouvent dans le fichier zip des sources de Forum82. Le fichier zip contenant l'ensemble des fichiers, il n'est donc pas ncessaire (ni recommand) d'envoyer tous les fichiers. Une fois les fichiers uploads, et les ventuelles modifications mentionnes dans le tableau effectues, cliquez sur le bouton "Procder  la mise  jour" situ en bas de page. Il sera alors procd  la mise  jour de la base de donnes, c&#39;est--dire que les requtes SQL ncessaires  la mise  jour du forum seront effecutes.<BR><BR>
<DIV align=center><INPUT type=submit onclick="return confirm('Attention, avant de procder  la mise  jour, vous devez avez upload les fichiers mentionns dans cette page !\n\nEtes-vous sr de vouloir effectuer la mise  jour?');" value="Procder  la mise  jour"></DIV>
<?php 
}
else
{
?>
<BR><BR>
<B>Procdure d&#39;installation :</B> Vous devez avoir uploader sur votre ftp la totalit des fichiers se trouvant dans le fichier zip,  l'exception bien sr de la documentation. Une fois cela effectu, et une fois le formulaire se trouvant ci-dessu rempli, cliquez sur le bouton "Installer".
<FORM action="updtool.<?php echo $e;?>" method=post>
<INPUT type=hidden name=action value=install>
Urlbase : <INPUT type=text name=urlbaseModif> (ne pas oublier le / final !!)<BR>
Serveur mysql : <INPUT type=text name=hostModif> (en gnral localhost) <BR>
Nom du comte mysql : <INPUT type=text name=mysql_accountModif><BR>
Password mysql : <INPUT type=text name=mysql_passwordModif><BR>
Nom de la base de donnes : <INPUT type=text name=mysql_dbModif><BR>
<INPUT type=hidden name=forumTitleModif value=Forum82>
<INPUT type=hidden name=enterMsgModif value=Bienvenue>
<INPUT type=hidden name=ShowNbAnswerModif value=true>
<INPUT type=hidden name=useSkinModif value=true>
<INPUT type=hidden name=autoReloadModif value=false>
<INPUT type=hidden name=gZipCompressionModif value=false>
Votre login administrateur : <INPUT type=text name=loginAdmin><BR>
Votre password : <INPUT type=text name=pass>
<BR><BR><DIV align="center"><INPUT type=submit value=Installer></DIV>
<?php 
   }
?>
</BODY>
</HTML>
